#include <iostream.h>
#include <stdlib.h>
#include <conio.h>
#include <new.h>
#include "color.h"
#include "scene.cpp"
#include "mode.h"

unsigned curbank;

class TWorkScene: public TScene {
  public:
    TWorkScene(double x, double y, double z):
              TScene(640, 480, 277, 320, 240, x, y, z, 0, 1, 0)
    {
      InitMode();
      curbank = 0;
    }
    void InitMode()
    {
      if (SetVesaMode(0x212) != 0x004F)
      {
        cout << "Unable to set video mode 320x200 16M colors\n";
        exit(1);
      }
    }
    virtual void PutPixel(int x, int y, TColor color);
    void DrawCrosshair();
    virtual void RenderScene()
    {
      TScene::RenderScene();
      DrawCrosshair();
    }
    ~TWorkScene()
    {
      SetTextMode();
    }
};

void TWorkScene::DrawCrosshair()
{
  TColor c;
  c.r = 0;
  c.g = 0;
  c.b = 255;

  for (int i = 0; i < 20; i++)
  {
    PutPixel(310 + i, 230 + i, c);
    PutPixel(329 - i, 230 + i, c);
  }
}

void TWorkScene::PutPixel(int x, int y, TColor color)
{
  unsigned char r = color.r, g = color.g, b = color.b;

  asm
  {
    mov ah, g
    mov al, b
    mov si, ax
    push 0A000h
    pop es
    mov bx, x
    mov ax, bx
    shl ax, 1
    add bx, ax
    mov ax, y
    mov dx, ax
    shr dx, 5
    shl ax, 11
    add ax, bx
    jnc @1
    inc dx
@1: cmp dx, curbank
    je @2

    push ax
    mov curbank, dx
    mov ax, 4F05h
    xor bx, bx
    int 10h
    pop ax

@2: mov di, ax
    mov ax, si
    stosw
    mov al, r
    stosb
  }
}

void my_handler()
{
  SetTextMode();
  cout << "Error: not enough memory\n";
  exit(1);
}

void main()
{
  set_new_handler(my_handler);
  TWorkScene *scene = new TWorkScene(0, 0, 100);

  scene -> AddObject(new THorizPlane(-50, 0, 0, 255));
  scene -> AddObject(new THorizPlane(250, 255, 255, 0));
  scene -> AddObject(new TVertXPlane(600, 0, 255, 0));
  scene -> AddObject(new TVertYPlane(-600, 0, 255, 0));
  scene -> AddObject(new TVertYPlane(400, 0, 255, 0));
  scene -> SetupLight(0, -200, 500, 50, 12000);
  scene -> SetupLight(1, 200, 300, 100, 24000);
  scene -> SetupLight(2, 0, 550, 100, 12000);
  scene -> SetupLight(3, -500, 500, 100, 20000);
  scene -> EnableLight(0);
  scene -> EnableLight(1);
  scene -> EnableLight(2);
  scene -> EnableLight(3);
  scene -> RenderScene();

  getch();

  delete scene;
}
